/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v55</h1>       <p>Introduced in Cloudera Manager 7.12.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.12.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.ApiHdfsReplicationArguments;
import com.cloudera.api.swagger.model.ApiRangerReplicationExportArgs;
import com.cloudera.api.swagger.model.ApiRangerReplicationImportArgs;
import com.cloudera.api.swagger.model.ApiRangerReplicationTransformArgs;
import com.cloudera.api.swagger.model.ApiServiceRef;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Replication arguments for replicating services defined in Ranger. It works the following way: &lt;ol&gt; &lt;li&gt;EXPORT the given services, policies and roles from the source Ranger, then COPY the exported result to destination, see available arguments in ApiRangerReplicationExportArgs. Note that if #getExportArgs() not provided, then services defined in Ranger won&#39;t be replicated, it will be skipped.&lt;/li&gt; &lt;li&gt;TRANSFORM the exported services, policies and roles from the source Ranger on the destination, see available arguments in ApiRangerReplicationTransformArgs&lt;/li&gt; &lt;li&gt;IMPORT the exported and transformed services, policies and roles from source to destination Ranger, see available arguments in ApiRangerReplicationImportArgs&lt;/li&gt; &lt;li&gt;If #getAuditLogDistCpArgs() is provided then the replication will distributed copy Ranger HDFS audit logs from source to destination, see available arguments in ApiHdfsReplicationArguments. If provided, then the mandatory fields are ApiHdfsReplicationArguments#getUserName() and ApiHdfsReplicationArguments#getSourceUser(). Any other ApiHdfsReplicationArguments fields could be provided, sourcePath and destinationPath will be set appropriately by CM, when not specified.&lt;/li&gt; &lt;/ol&gt; Note that at least one of #getExportArgs(), #getAuditLogDistCpArgs() must be provided, otherwise the replication would not do anything.
 */
@ApiModel(description = "Replication arguments for replicating services defined in Ranger. It works the following way: <ol> <li>EXPORT the given services, policies and roles from the source Ranger, then COPY the exported result to destination, see available arguments in ApiRangerReplicationExportArgs. Note that if #getExportArgs() not provided, then services defined in Ranger won't be replicated, it will be skipped.</li> <li>TRANSFORM the exported services, policies and roles from the source Ranger on the destination, see available arguments in ApiRangerReplicationTransformArgs</li> <li>IMPORT the exported and transformed services, policies and roles from source to destination Ranger, see available arguments in ApiRangerReplicationImportArgs</li> <li>If #getAuditLogDistCpArgs() is provided then the replication will distributed copy Ranger HDFS audit logs from source to destination, see available arguments in ApiHdfsReplicationArguments. If provided, then the mandatory fields are ApiHdfsReplicationArguments#getUserName() and ApiHdfsReplicationArguments#getSourceUser(). Any other ApiHdfsReplicationArguments fields could be provided, sourcePath and destinationPath will be set appropriately by CM, when not specified.</li> </ol> Note that at least one of #getExportArgs(), #getAuditLogDistCpArgs() must be provided, otherwise the replication would not do anything.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-03-14T11:15:13.362Z")
public class ApiRangerReplicationArgs {
  @SerializedName("sourceRangerService")
  private ApiServiceRef sourceRangerService = null;

  @SerializedName("exportArgs")
  private ApiRangerReplicationExportArgs exportArgs = null;

  @SerializedName("transformArgs")
  private ApiRangerReplicationTransformArgs transformArgs = null;

  @SerializedName("importArgs")
  private ApiRangerReplicationImportArgs importArgs = null;

  @SerializedName("auditLogDistCpArgs")
  private ApiHdfsReplicationArguments auditLogDistCpArgs = null;

  public ApiRangerReplicationArgs sourceRangerService(ApiServiceRef sourceRangerService) {
    this.sourceRangerService = sourceRangerService;
    return this;
  }

   /**
   * The source service to replicate from.
   * @return sourceRangerService
  **/
  @ApiModelProperty(value = "The source service to replicate from.")
  public ApiServiceRef getSourceRangerService() {
    return sourceRangerService;
  }

  public void setSourceRangerService(ApiServiceRef sourceRangerService) {
    this.sourceRangerService = sourceRangerService;
  }

  public ApiRangerReplicationArgs exportArgs(ApiRangerReplicationExportArgs exportArgs) {
    this.exportArgs = exportArgs;
    return this;
  }

   /**
   * If provided then replicate services defined in Ranger from source to destination. If not provided then it will be skipped. Mandatory field is ApiRangerReplicationExportArgs#getRangerServiceNames().
   * @return exportArgs
  **/
  @ApiModelProperty(value = "If provided then replicate services defined in Ranger from source to destination. If not provided then it will be skipped. Mandatory field is ApiRangerReplicationExportArgs#getRangerServiceNames().")
  public ApiRangerReplicationExportArgs getExportArgs() {
    return exportArgs;
  }

  public void setExportArgs(ApiRangerReplicationExportArgs exportArgs) {
    this.exportArgs = exportArgs;
  }

  public ApiRangerReplicationArgs transformArgs(ApiRangerReplicationTransformArgs transformArgs) {
    this.transformArgs = transformArgs;
    return this;
  }

   /**
   * Replication arguments for the TRANSFORM operation. Relevant only if #getExportArgs() was provided.
   * @return transformArgs
  **/
  @ApiModelProperty(value = "Replication arguments for the TRANSFORM operation. Relevant only if #getExportArgs() was provided.")
  public ApiRangerReplicationTransformArgs getTransformArgs() {
    return transformArgs;
  }

  public void setTransformArgs(ApiRangerReplicationTransformArgs transformArgs) {
    this.transformArgs = transformArgs;
  }

  public ApiRangerReplicationArgs importArgs(ApiRangerReplicationImportArgs importArgs) {
    this.importArgs = importArgs;
    return this;
  }

   /**
   * Replication arguments for the IMPORT operation. Relevant only if #getExportArgs() was provided.
   * @return importArgs
  **/
  @ApiModelProperty(value = "Replication arguments for the IMPORT operation. Relevant only if #getExportArgs() was provided.")
  public ApiRangerReplicationImportArgs getImportArgs() {
    return importArgs;
  }

  public void setImportArgs(ApiRangerReplicationImportArgs importArgs) {
    this.importArgs = importArgs;
  }

  public ApiRangerReplicationArgs auditLogDistCpArgs(ApiHdfsReplicationArguments auditLogDistCpArgs) {
    this.auditLogDistCpArgs = auditLogDistCpArgs;
    return this;
  }

   /**
   * If provided then the replication will distributed copy Ranger HDFS audit logs from source to destination HDFS. If not provided then it will be skipped. Mandatory fields are ApiHdfsReplicationArguments#getUserName() and ApiHdfsReplicationArguments#getSourceUser(). Any other ApiHdfsReplicationArguments fields could be provided, sourcePath and destinationPath will be set appropriately by CM, when not specified.
   * @return auditLogDistCpArgs
  **/
  @ApiModelProperty(value = "If provided then the replication will distributed copy Ranger HDFS audit logs from source to destination HDFS. If not provided then it will be skipped. Mandatory fields are ApiHdfsReplicationArguments#getUserName() and ApiHdfsReplicationArguments#getSourceUser(). Any other ApiHdfsReplicationArguments fields could be provided, sourcePath and destinationPath will be set appropriately by CM, when not specified.")
  public ApiHdfsReplicationArguments getAuditLogDistCpArgs() {
    return auditLogDistCpArgs;
  }

  public void setAuditLogDistCpArgs(ApiHdfsReplicationArguments auditLogDistCpArgs) {
    this.auditLogDistCpArgs = auditLogDistCpArgs;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiRangerReplicationArgs apiRangerReplicationArgs = (ApiRangerReplicationArgs) o;
    return Objects.equals(this.sourceRangerService, apiRangerReplicationArgs.sourceRangerService) &&
        Objects.equals(this.exportArgs, apiRangerReplicationArgs.exportArgs) &&
        Objects.equals(this.transformArgs, apiRangerReplicationArgs.transformArgs) &&
        Objects.equals(this.importArgs, apiRangerReplicationArgs.importArgs) &&
        Objects.equals(this.auditLogDistCpArgs, apiRangerReplicationArgs.auditLogDistCpArgs);
  }

  @Override
  public int hashCode() {
    return Objects.hash(sourceRangerService, exportArgs, transformArgs, importArgs, auditLogDistCpArgs);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiRangerReplicationArgs {\n");
    
    sb.append("    sourceRangerService: ").append(toIndentedString(sourceRangerService)).append("\n");
    sb.append("    exportArgs: ").append(toIndentedString(exportArgs)).append("\n");
    sb.append("    transformArgs: ").append(toIndentedString(transformArgs)).append("\n");
    sb.append("    importArgs: ").append(toIndentedString(importArgs)).append("\n");
    sb.append("    auditLogDistCpArgs: ").append(toIndentedString(auditLogDistCpArgs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

