# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v55</h1>       <p>Introduced in Cloudera Manager 7.12.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>

    OpenAPI spec version: 7.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ApiConfigPolicy(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'version': 'str',
        'description': 'str',
        'config_enforcements': 'list[ApiConfigEnforcement]'
    }

    attribute_map = {
        'name': 'name',
        'version': 'version',
        'description': 'description',
        'config_enforcements': 'configEnforcements'
    }

    def __init__(self, name=None, version=None, description=None, config_enforcements=None):
        """
        ApiConfigPolicy - a model defined in Swagger
        """

        self._name = None
        self._version = None
        self._description = None
        self._config_enforcements = None

        if name is not None:
          self.name = name
        if version is not None:
          self.version = version
        if description is not None:
          self.description = description
        if config_enforcements is not None:
          self.config_enforcements = config_enforcements

    @property
    def name(self):
        """
        Gets the name of this ApiConfigPolicy.
        The policy name.

        :return: The name of this ApiConfigPolicy.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ApiConfigPolicy.
        The policy name.

        :param name: The name of this ApiConfigPolicy.
        :type: str
        """

        self._name = name

    @property
    def version(self):
        """
        Gets the version of this ApiConfigPolicy.
        The policy version. Useful to differentiate different versions of the same policy. Optional

        :return: The version of this ApiConfigPolicy.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this ApiConfigPolicy.
        The policy version. Useful to differentiate different versions of the same policy. Optional

        :param version: The version of this ApiConfigPolicy.
        :type: str
        """

        self._version = version

    @property
    def description(self):
        """
        Gets the description of this ApiConfigPolicy.
        A human readable version of what this policy does. Optional

        :return: The description of this ApiConfigPolicy.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this ApiConfigPolicy.
        A human readable version of what this policy does. Optional

        :param description: The description of this ApiConfigPolicy.
        :type: str
        """

        self._description = description

    @property
    def config_enforcements(self):
        """
        Gets the config_enforcements of this ApiConfigPolicy.
        A list of configuration enforcements.

        :return: The config_enforcements of this ApiConfigPolicy.
        :rtype: list[ApiConfigEnforcement]
        """
        return self._config_enforcements

    @config_enforcements.setter
    def config_enforcements(self, config_enforcements):
        """
        Sets the config_enforcements of this ApiConfigPolicy.
        A list of configuration enforcements.

        :param config_enforcements: The config_enforcements of this ApiConfigPolicy.
        :type: list[ApiConfigEnforcement]
        """

        self._config_enforcements = config_enforcements

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApiConfigPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
