# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v55</h1>       <p>Introduced in Cloudera Manager 7.12.0</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>

    OpenAPI spec version: 7.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ApiIcebergReplicationArguments(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'source_iceberg_replication_service': 'ApiServiceRef',
        'policy_name': 'str',
        'included_table_filters': 'list[ApiHiveTable]',
        'excluded_table_filters': 'list[ApiHiveTable]',
        'batch_size': 'int',
        'proxy_name': 'str',
        'export_yarn_options': 'IcebergReplicationYarnOptions',
        'xfer_yarn_options': 'IcebergReplicationYarnOptions',
        'sync_yarn_options': 'IcebergReplicationYarnOptions',
        'should_replicate_column_stats': 'bool',
        'safety_valves_source': 'dict(str, IcebergReplicationSafetyValve)',
        'safety_valves_target': 'dict(str, IcebergReplicationSafetyValve)'
    }

    attribute_map = {
        'source_iceberg_replication_service': 'sourceIcebergReplicationService',
        'policy_name': 'policyName',
        'included_table_filters': 'includedTableFilters',
        'excluded_table_filters': 'excludedTableFilters',
        'batch_size': 'batchSize',
        'proxy_name': 'proxyName',
        'export_yarn_options': 'exportYarnOptions',
        'xfer_yarn_options': 'xferYarnOptions',
        'sync_yarn_options': 'syncYarnOptions',
        'should_replicate_column_stats': 'shouldReplicateColumnStats',
        'safety_valves_source': 'safetyValvesSource',
        'safety_valves_target': 'safetyValvesTarget'
    }

    def __init__(self, source_iceberg_replication_service=None, policy_name=None, included_table_filters=None, excluded_table_filters=None, batch_size=None, proxy_name=None, export_yarn_options=None, xfer_yarn_options=None, sync_yarn_options=None, should_replicate_column_stats=None, safety_valves_source=None, safety_valves_target=None):
        """
        ApiIcebergReplicationArguments - a model defined in Swagger
        """

        self._source_iceberg_replication_service = None
        self._policy_name = None
        self._included_table_filters = None
        self._excluded_table_filters = None
        self._batch_size = None
        self._proxy_name = None
        self._export_yarn_options = None
        self._xfer_yarn_options = None
        self._sync_yarn_options = None
        self._should_replicate_column_stats = None
        self._safety_valves_source = None
        self._safety_valves_target = None

        if source_iceberg_replication_service is not None:
          self.source_iceberg_replication_service = source_iceberg_replication_service
        if policy_name is not None:
          self.policy_name = policy_name
        if included_table_filters is not None:
          self.included_table_filters = included_table_filters
        if excluded_table_filters is not None:
          self.excluded_table_filters = excluded_table_filters
        if batch_size is not None:
          self.batch_size = batch_size
        if proxy_name is not None:
          self.proxy_name = proxy_name
        if export_yarn_options is not None:
          self.export_yarn_options = export_yarn_options
        if xfer_yarn_options is not None:
          self.xfer_yarn_options = xfer_yarn_options
        if sync_yarn_options is not None:
          self.sync_yarn_options = sync_yarn_options
        if should_replicate_column_stats is not None:
          self.should_replicate_column_stats = should_replicate_column_stats
        if safety_valves_source is not None:
          self.safety_valves_source = safety_valves_source
        if safety_valves_target is not None:
          self.safety_valves_target = safety_valves_target

    @property
    def source_iceberg_replication_service(self):
        """
        Gets the source_iceberg_replication_service of this ApiIcebergReplicationArguments.
        

        :return: The source_iceberg_replication_service of this ApiIcebergReplicationArguments.
        :rtype: ApiServiceRef
        """
        return self._source_iceberg_replication_service

    @source_iceberg_replication_service.setter
    def source_iceberg_replication_service(self, source_iceberg_replication_service):
        """
        Sets the source_iceberg_replication_service of this ApiIcebergReplicationArguments.
        

        :param source_iceberg_replication_service: The source_iceberg_replication_service of this ApiIcebergReplicationArguments.
        :type: ApiServiceRef
        """

        self._source_iceberg_replication_service = source_iceberg_replication_service

    @property
    def policy_name(self):
        """
        Gets the policy_name of this ApiIcebergReplicationArguments.
        

        :return: The policy_name of this ApiIcebergReplicationArguments.
        :rtype: str
        """
        return self._policy_name

    @policy_name.setter
    def policy_name(self, policy_name):
        """
        Sets the policy_name of this ApiIcebergReplicationArguments.
        

        :param policy_name: The policy_name of this ApiIcebergReplicationArguments.
        :type: str
        """

        self._policy_name = policy_name

    @property
    def included_table_filters(self):
        """
        Gets the included_table_filters of this ApiIcebergReplicationArguments.
        

        :return: The included_table_filters of this ApiIcebergReplicationArguments.
        :rtype: list[ApiHiveTable]
        """
        return self._included_table_filters

    @included_table_filters.setter
    def included_table_filters(self, included_table_filters):
        """
        Sets the included_table_filters of this ApiIcebergReplicationArguments.
        

        :param included_table_filters: The included_table_filters of this ApiIcebergReplicationArguments.
        :type: list[ApiHiveTable]
        """

        self._included_table_filters = included_table_filters

    @property
    def excluded_table_filters(self):
        """
        Gets the excluded_table_filters of this ApiIcebergReplicationArguments.
        

        :return: The excluded_table_filters of this ApiIcebergReplicationArguments.
        :rtype: list[ApiHiveTable]
        """
        return self._excluded_table_filters

    @excluded_table_filters.setter
    def excluded_table_filters(self, excluded_table_filters):
        """
        Sets the excluded_table_filters of this ApiIcebergReplicationArguments.
        

        :param excluded_table_filters: The excluded_table_filters of this ApiIcebergReplicationArguments.
        :type: list[ApiHiveTable]
        """

        self._excluded_table_filters = excluded_table_filters

    @property
    def batch_size(self):
        """
        Gets the batch_size of this ApiIcebergReplicationArguments.
        

        :return: The batch_size of this ApiIcebergReplicationArguments.
        :rtype: int
        """
        return self._batch_size

    @batch_size.setter
    def batch_size(self, batch_size):
        """
        Sets the batch_size of this ApiIcebergReplicationArguments.
        

        :param batch_size: The batch_size of this ApiIcebergReplicationArguments.
        :type: int
        """

        self._batch_size = batch_size

    @property
    def proxy_name(self):
        """
        Gets the proxy_name of this ApiIcebergReplicationArguments.
        

        :return: The proxy_name of this ApiIcebergReplicationArguments.
        :rtype: str
        """
        return self._proxy_name

    @proxy_name.setter
    def proxy_name(self, proxy_name):
        """
        Sets the proxy_name of this ApiIcebergReplicationArguments.
        

        :param proxy_name: The proxy_name of this ApiIcebergReplicationArguments.
        :type: str
        """

        self._proxy_name = proxy_name

    @property
    def export_yarn_options(self):
        """
        Gets the export_yarn_options of this ApiIcebergReplicationArguments.
        

        :return: The export_yarn_options of this ApiIcebergReplicationArguments.
        :rtype: IcebergReplicationYarnOptions
        """
        return self._export_yarn_options

    @export_yarn_options.setter
    def export_yarn_options(self, export_yarn_options):
        """
        Sets the export_yarn_options of this ApiIcebergReplicationArguments.
        

        :param export_yarn_options: The export_yarn_options of this ApiIcebergReplicationArguments.
        :type: IcebergReplicationYarnOptions
        """

        self._export_yarn_options = export_yarn_options

    @property
    def xfer_yarn_options(self):
        """
        Gets the xfer_yarn_options of this ApiIcebergReplicationArguments.
        

        :return: The xfer_yarn_options of this ApiIcebergReplicationArguments.
        :rtype: IcebergReplicationYarnOptions
        """
        return self._xfer_yarn_options

    @xfer_yarn_options.setter
    def xfer_yarn_options(self, xfer_yarn_options):
        """
        Sets the xfer_yarn_options of this ApiIcebergReplicationArguments.
        

        :param xfer_yarn_options: The xfer_yarn_options of this ApiIcebergReplicationArguments.
        :type: IcebergReplicationYarnOptions
        """

        self._xfer_yarn_options = xfer_yarn_options

    @property
    def sync_yarn_options(self):
        """
        Gets the sync_yarn_options of this ApiIcebergReplicationArguments.
        

        :return: The sync_yarn_options of this ApiIcebergReplicationArguments.
        :rtype: IcebergReplicationYarnOptions
        """
        return self._sync_yarn_options

    @sync_yarn_options.setter
    def sync_yarn_options(self, sync_yarn_options):
        """
        Sets the sync_yarn_options of this ApiIcebergReplicationArguments.
        

        :param sync_yarn_options: The sync_yarn_options of this ApiIcebergReplicationArguments.
        :type: IcebergReplicationYarnOptions
        """

        self._sync_yarn_options = sync_yarn_options

    @property
    def should_replicate_column_stats(self):
        """
        Gets the should_replicate_column_stats of this ApiIcebergReplicationArguments.
        

        :return: The should_replicate_column_stats of this ApiIcebergReplicationArguments.
        :rtype: bool
        """
        return self._should_replicate_column_stats

    @should_replicate_column_stats.setter
    def should_replicate_column_stats(self, should_replicate_column_stats):
        """
        Sets the should_replicate_column_stats of this ApiIcebergReplicationArguments.
        

        :param should_replicate_column_stats: The should_replicate_column_stats of this ApiIcebergReplicationArguments.
        :type: bool
        """

        self._should_replicate_column_stats = should_replicate_column_stats

    @property
    def safety_valves_source(self):
        """
        Gets the safety_valves_source of this ApiIcebergReplicationArguments.
        

        :return: The safety_valves_source of this ApiIcebergReplicationArguments.
        :rtype: dict(str, IcebergReplicationSafetyValve)
        """
        return self._safety_valves_source

    @safety_valves_source.setter
    def safety_valves_source(self, safety_valves_source):
        """
        Sets the safety_valves_source of this ApiIcebergReplicationArguments.
        

        :param safety_valves_source: The safety_valves_source of this ApiIcebergReplicationArguments.
        :type: dict(str, IcebergReplicationSafetyValve)
        """

        self._safety_valves_source = safety_valves_source

    @property
    def safety_valves_target(self):
        """
        Gets the safety_valves_target of this ApiIcebergReplicationArguments.
        

        :return: The safety_valves_target of this ApiIcebergReplicationArguments.
        :rtype: dict(str, IcebergReplicationSafetyValve)
        """
        return self._safety_valves_target

    @safety_valves_target.setter
    def safety_valves_target(self, safety_valves_target):
        """
        Sets the safety_valves_target of this ApiIcebergReplicationArguments.
        

        :param safety_valves_target: The safety_valves_target of this ApiIcebergReplicationArguments.
        :type: dict(str, IcebergReplicationSafetyValve)
        """

        self._safety_valves_target = safety_valves_target

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApiIcebergReplicationArguments):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
